<?php
namespace Incoviba\Controller;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Incoviba\Common\Alias\View;
use Incoviba\Common\Implement\Exception\EmptyResult;
use Incoviba\Repository;
use Incoviba\Model;

class Proyectos
{
    public function __invoke(ServerRequestInterface $request, ResponseInterface $response, View $view): ResponseInterface
    {
        return $view->render($response, 'proyectos.list');
    }
    public function list(ServerRequestInterface $request, ResponseInterface $response, Repository\Proyecto $proyectoRepository): ResponseInterface
    {
        $output = ['total' => 0];
        try {
            $proyectos = $proyectoRepository->fetchAllActive();
            $output['proyectos'] = $proyectos;
            $output['total'] = count($proyectos);
        } catch (EmptyResult) {}
        $response->getBody()->write(json_encode($output));
        return $response->withHeader('Content-Type', 'application/json');
    }
    public function unidades(ServerRequestInterface $request, ResponseInterface $response, Repository\Venta\Unidad $unidadRepository, int $proyecto_id): ResponseInterface
    {
        $output = ['proyecto_id' => $proyecto_id, 'unidades' => [], 'total' => 0];
        try {
            $unidades = $unidadRepository->fetchDisponiblesByProyecto($proyecto_id);
            $tipos = [];
            foreach ($unidades as $unidad) {
                if (!isset($tipos[$unidad->proyectoTipoUnidad->tipoUnidad->descripcion])) {
                    $tipos[$unidad->proyectoTipoUnidad->tipoUnidad->descripcion] = [];
                }
                $tipos[$unidad->proyectoTipoUnidad->tipoUnidad->descripcion] []= $unidad;
            }
            foreach ($tipos as &$subtipo) {
                usort($subtipo, function(Model\Venta\Unidad $a, Model\Venta\Unidad $b) {
                    return strcmp(str_pad($a->descripcion, 4, '0', STR_PAD_LEFT), str_pad($b->descripcion, 4, '0', STR_PAD_LEFT));
                });
            }
            $output['unidades'] = $tipos;
            $output['total'] = count($unidades);
        } catch (EmptyResult) {}
        $response->getBody()->write(json_encode($output));
        return $response->withHeader('Content-Type', 'application/json');
    }
}
